import sys
import gensim
import sklearn
import numpy as np
import re
 
from gensim.models.doc2vec import Doc2Vec, LabeledSentence
 
TaggededDocument = gensim.models.doc2vec.TaggedDocument
 

all_anchor = []
all_sentence = []

 
def train(x_train, size=200, epoch_num=1):
    model_dm = Doc2Vec(x_train,min_count=1, window = 3, size = size, sample=1e-3, negative=5, workers=4)
    model_dm.train(x_train, total_examples=model_dm.corpus_count, epochs=70)
    model_dm.save('anchor')
 
    return model_dm
 
def test(anc):
    model_dm = Doc2Vec.load("anchor")
    test_text = re.sub("[^\w]", " ",  anc).split()
    inferred_vector_dm = model_dm.infer_vector(test_text)
    #print inferred_vector_dm
    sims = model_dm.docvecs.most_similar([inferred_vector_dm], topn=2)

 
    return sims

def find_close():
    for line in all_anchor:
        split_anchor = []
        model_dm = Doc2Vec.load("anchor")
        test_text = re.sub("[^\w]", " ",  line).split()
        inferred_vector_dm = model_dm.infer_vector(test_text)
        #print inferred_vector_dm
        sims = model_dm.docvecs.most_similar([inferred_vector_dm], topn=1)
        sim2 =  sorted(sims, key=lambda item: item[1], reverse=True)
        for count,anc in sim2:
            sentence = x_train[count]
            words = ''
            for word in sentence[0]:
                words = words + word + ' '
            if line[:-1] == words[:-1]:
                continue
            if line[:-1] in five_ini_cluster[0] or line[:-1] in five_ini_cluster[1] or line[:-1] in five_ini_cluster[2] or line[:-1] in five_ini_cluster[3] or line[:-1] in five_ini_cluster[4]:
                continue
            else:
                if words[:-1] in five_ini_cluster[0] and anc > 0.6:
                    print "enter cluster1"
                    five_ini_cluster[0].append(line[:-1])
                    break
                elif words[:-1] in five_ini_cluster[1] and anc > 0.6:
                    print "enter cluster2"
                    five_ini_cluster[1].append(line[:-1])
                    break
                elif words[:-1] in five_ini_cluster[2] and anc > 0.6:
                    print "enter cluster3"
                    five_ini_cluster[2].append(line[:-1])
                    break
                elif words[:-1] in five_ini_cluster[3] and anc > 0.6:
                    print "enter cluster4"
                    five_ini_cluster[3].append(line[:-1])
                    break
                elif words[:-1] in five_ini_cluster[4] and count > 0.6:
                    print "enter cluster5"
                    five_ini_cluster[4].append(line[:-1])
                    break
                else:
                    continue
    return

with open("anchor2.txt") as infile:
    docs = infile.readlines()
'''
# using sentence
with open("sentence.txt") as infile:
    docs = infile.readlines()
infile.close()
'''
with open("anchor2.txt") as infile1, open("sentence2.txt") as infile2:
    for anc,sen in zip(infile1, infile2):
        if not sen[:-1] in all_sentence and not anc[:-1] in all_anchor:
            all_sentence.append(sen[:-1])
            all_anchor.append(anc[:-1])
infile1.close()
infile2.close()
    # print len(docs)
DIC = dict(zip(all_anchor, all_sentence))
print "DIC length is:"
print len(DIC)
'''
with open("sentence.txt") as infile:
    for anc in infile:
        if not anc[:-1] in all_anchor:
            all_anchor.append(anc[:-1])
infile.close()
'''
x_train = []

#y = np.concatenate(np.ones(len(docs)))
for i, text in enumerate(docs):
    word_list = text.split(' ')
    l = len(word_list)
    word_list[l-1] = word_list[l-1].strip()
    document = TaggededDocument(word_list, tags=[i])
    x_train.append(document)


model_dm = train(x_train)
top_ini = []
top_ini_tmp = []
for anchor in all_anchor:
    sims = test(anchor)

    for count, sim in sims:
        sentence = x_train[count]

        result_pair = []
        tmp_pair = []
        words = ''
        for word in sentence[0]:
            words = words + word + ' '
        if anchor[:-1] == words[:-1]:
            continue

        result_pair.append(sim)
        result_pair.append(anchor[:-1])
        result_pair.append(words[:-1])
        tmp_pair.append(anchor[:-1])
        tmp_pair.append(words[:-1])
        
        if tmp_pair not in top_ini_tmp:
            top_ini_tmp.append(tmp_pair)
            top_ini.append(result_pair)
top_ini =  sorted(top_ini, key=lambda item: item[0], reverse=True)

five_ini_cluster = []
print "top ini1 is:"
print top_ini[0]
print "top ini2 is:"
print top_ini[1]
print "top ini3 is:"
print top_ini[2]
print "top ini4 is:"
print top_ini[3]
print "top ini5 is:"
print top_ini[4]
five_ini_cluster.append(top_ini[0][1:3])
five_ini_cluster.append(top_ini[1][1:3])
five_ini_cluster.append(top_ini[2][1:3])
five_ini_cluster.append(top_ini[3][1:3])
five_ini_cluster.append(top_ini[4][1:3])



for i in range(1):
    find_close()

'''
with open("result.txt", "w") as outfile:
    outfile.write("Cluster1:\n")
    for sts in five_ini_cluster[0]:
        outfile.write(sts)
        
        outfile.write("\n")
    outfile.write("\nCluster2:\n")
    for sts in five_ini_cluster[1]:
        outfile.write(sts)
        outfile.write("\n")
    outfile.write("\nCluster3:\n")
    for sts in five_ini_cluster[2]:
        outfile.write(sts)
        outfile.write("\n")
    outfile.write("\nCluster4:\n")
    for sts in five_ini_cluster[3]:
        outfile.write(sts)
        outfile.write("\n")
    outfile.write("\nCluster5:\n")
    for sts in five_ini_cluster[4]:
        outfile.write(sts)
        outfile.write("\n")
outfile.close()
'''


with open("result.txt", "w") as outfile:
    outfile.write("Cluster1:\n")
    for anchor in five_ini_cluster[0]:
        sts = DIC.get(anchor)
        outfile.write("    Anchor:")
        outfile.write(anchor)
        outfile.write("\n")
        outfile.write("    Sentence:")
        outfile.write(sts)
        
        outfile.write("\n")
    outfile.write("\nCluster2:\n")
    for anchor in five_ini_cluster[1]:
        sts = DIC.get(anchor)
        outfile.write("    Anchor:")
        outfile.write(anchor)
        outfile.write("\n")
        outfile.write("    Sentence:")
        outfile.write(sts)
        outfile.write("\n")
    outfile.write("\nCluster3:\n")
    for anchor in five_ini_cluster[2]:
        sts = DIC.get(anchor)
        outfile.write("    Anchor:")
        outfile.write(anchor)
        outfile.write("\n")
        outfile.write("    Sentence:")
        outfile.write(sts)
        outfile.write("\n")
    outfile.write("\nCluster4:\n")
    for anchor in five_ini_cluster[3]:
        sts = DIC.get(anchor)
        outfile.write("    Anchor:")
        outfile.write(anchor)
        outfile.write("\n")
        outfile.write("    Sentence:")
        outfile.write(sts)
        outfile.write("\n")
    outfile.write("\nCluster5:\n")
    for anchor in five_ini_cluster[4]:
        sts = DIC.get(anchor)
        outfile.write("    Anchor:")
        outfile.write(anchor)
        outfile.write("\n")
        outfile.write("    Sentence:")
        outfile.write(sts)
        outfile.write("\n")
outfile.close()
