package ca.nrc.naryrelations;

import java.io.File;

import org.apache.uima.jcas.JCas;

public class ReadFileWithCasualtiesRelation  {
	
	private final static String[][] MAPPINGS = new String[][] {
	    new String[] {"de-tudarmstadt-ukp-dkpro-core-api-ner-type-Person", "de.tudarmstadt.ukp.dkpro.core.api.ner.type.Person"},			
	    new String[] {"de-tudarmstadt-ukp-dkpro-core-api-ner-type-Date", "de.tudarmstadt.ukp.dkpro.core.api.ner.type.Date"},
	    
	    new String[] {"LOC", "de.tudarmstadt.ukp.dkpro.core.api.ner.type.Location"},
	    new String[] {"ORG", "de.tudarmstadt.ukp.dkpro.core.api.ner.type.Organization"},
	    new String[] {"PER", "de.tudarmstadt.ukp.dkpro.core.api.ner.type.Person"},			
	    new String[] {"DATE", "de.tudarmstadt.ukp.dkpro.core.api.ner.type.Date"},
	    new String[] {"TIME", "de.tudarmstadt.ukp.dkpro.core.api.ner.type.Time"},
	    new String[] {"CARDINAL", "de.tudarmstadt.ukp.dkpro.core.api.ner.type.Cardinal"},
	    new String[] {"ORDINAL", "de.tudarmstadt.ukp.dkpro.core.api.ner.type.Ordinal"},
	    
	    new String[] {"MMLite", "de.tudarmstadt.ukp.dkpro.core.api.ner.type.Disease"},
	    
	    new String[] {"ca-nrc-t2rels-freetext-annotations-CasualtiesRelationNary", "ca.nrc.t2rels.freetext.annotations.CasualtiesRelationNary"},	    
	    new String[] {"ca-nrc-BirthEvent", "ca.nrc.BirthEvent"}
	};
	
	public static void main(String[] args) throws Exception {
		
		File westnileFile = new File(args[0]);
		System.out.println("Reading brat file: "+westnileFile);
		JCas jcas = BratUtils.readBratFile(westnileFile, MAPPINGS);	
	}
}
